<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvDatastoreItemData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvDatastoreItemData extends AbstractStructArrayBase
{
    /**
     * The PvDatastoreItemData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvDatastoreItemData[]
     */
    public $PvDatastoreItemData;
    /**
     * Constructor method for ArrayOfPvDatastoreItemData
     * @uses ArrayOfPvDatastoreItemData::setPvDatastoreItemData()
     * @param \StructType\PvDatastoreItemData[] $pvDatastoreItemData
     */
    public function __construct(array $pvDatastoreItemData = array())
    {
        $this
            ->setPvDatastoreItemData($pvDatastoreItemData);
    }
    /**
     * Get PvDatastoreItemData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvDatastoreItemData[]|null
     */
    public function getPvDatastoreItemData()
    {
        return isset($this->PvDatastoreItemData) ? $this->PvDatastoreItemData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvDatastoreItemData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvDatastoreItemData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvDatastoreItemDataForArrayConstraintsFromSetPvDatastoreItemData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvDatastoreItemDataPvDatastoreItemDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvDatastoreItemDataPvDatastoreItemDataItem instanceof \StructType\PvDatastoreItemData) {
                $invalidValues[] = is_object($arrayOfPvDatastoreItemDataPvDatastoreItemDataItem) ? get_class($arrayOfPvDatastoreItemDataPvDatastoreItemDataItem) : sprintf('%s(%s)', gettype($arrayOfPvDatastoreItemDataPvDatastoreItemDataItem), var_export($arrayOfPvDatastoreItemDataPvDatastoreItemDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvDatastoreItemData property can only contain items of type \StructType\PvDatastoreItemData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvDatastoreItemData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemData[] $pvDatastoreItemData
     * @return \ArrayType\ArrayOfPvDatastoreItemData
     */
    public function setPvDatastoreItemData(array $pvDatastoreItemData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvDatastoreItemDataArrayErrorMessage = self::validatePvDatastoreItemDataForArrayConstraintsFromSetPvDatastoreItemData($pvDatastoreItemData))) {
            throw new \InvalidArgumentException($pvDatastoreItemDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvDatastoreItemData) || (is_array($pvDatastoreItemData) && empty($pvDatastoreItemData))) {
            unset($this->PvDatastoreItemData);
        } else {
            $this->PvDatastoreItemData = $pvDatastoreItemData;
        }
        return $this;
    }
    /**
     * Add item to PvDatastoreItemData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemData $item
     * @return \ArrayType\ArrayOfPvDatastoreItemData
     */
    public function addToPvDatastoreItemData(\StructType\PvDatastoreItemData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvDatastoreItemData) {
            throw new \InvalidArgumentException(sprintf('The PvDatastoreItemData property can only contain items of type \StructType\PvDatastoreItemData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvDatastoreItemData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvDatastoreItemData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvDatastoreItemData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvDatastoreItemData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvDatastoreItemData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvDatastoreItemData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvDatastoreItemData
     */
    public function getAttributeName()
    {
        return 'PvDatastoreItemData';
    }
}
