<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvDatastoreItemDataWithParent ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvDatastoreItemDataWithParent extends AbstractStructArrayBase
{
    /**
     * The PvDatastoreItemDataWithParent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvDatastoreItemDataWithParent[]
     */
    public $PvDatastoreItemDataWithParent;
    /**
     * Constructor method for ArrayOfPvDatastoreItemDataWithParent
     * @uses ArrayOfPvDatastoreItemDataWithParent::setPvDatastoreItemDataWithParent()
     * @param \StructType\PvDatastoreItemDataWithParent[] $pvDatastoreItemDataWithParent
     */
    public function __construct(array $pvDatastoreItemDataWithParent = array())
    {
        $this
            ->setPvDatastoreItemDataWithParent($pvDatastoreItemDataWithParent);
    }
    /**
     * Get PvDatastoreItemDataWithParent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvDatastoreItemDataWithParent[]|null
     */
    public function getPvDatastoreItemDataWithParent()
    {
        return isset($this->PvDatastoreItemDataWithParent) ? $this->PvDatastoreItemDataWithParent : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvDatastoreItemDataWithParent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvDatastoreItemDataWithParent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvDatastoreItemDataWithParentForArrayConstraintsFromSetPvDatastoreItemDataWithParent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvDatastoreItemDataWithParentPvDatastoreItemDataWithParentItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvDatastoreItemDataWithParentPvDatastoreItemDataWithParentItem instanceof \StructType\PvDatastoreItemDataWithParent) {
                $invalidValues[] = is_object($arrayOfPvDatastoreItemDataWithParentPvDatastoreItemDataWithParentItem) ? get_class($arrayOfPvDatastoreItemDataWithParentPvDatastoreItemDataWithParentItem) : sprintf('%s(%s)', gettype($arrayOfPvDatastoreItemDataWithParentPvDatastoreItemDataWithParentItem), var_export($arrayOfPvDatastoreItemDataWithParentPvDatastoreItemDataWithParentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvDatastoreItemDataWithParent property can only contain items of type \StructType\PvDatastoreItemDataWithParent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvDatastoreItemDataWithParent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemDataWithParent[] $pvDatastoreItemDataWithParent
     * @return \ArrayType\ArrayOfPvDatastoreItemDataWithParent
     */
    public function setPvDatastoreItemDataWithParent(array $pvDatastoreItemDataWithParent = array())
    {
        // validation for constraint: array
        if ('' !== ($pvDatastoreItemDataWithParentArrayErrorMessage = self::validatePvDatastoreItemDataWithParentForArrayConstraintsFromSetPvDatastoreItemDataWithParent($pvDatastoreItemDataWithParent))) {
            throw new \InvalidArgumentException($pvDatastoreItemDataWithParentArrayErrorMessage, __LINE__);
        }
        if (is_null($pvDatastoreItemDataWithParent) || (is_array($pvDatastoreItemDataWithParent) && empty($pvDatastoreItemDataWithParent))) {
            unset($this->PvDatastoreItemDataWithParent);
        } else {
            $this->PvDatastoreItemDataWithParent = $pvDatastoreItemDataWithParent;
        }
        return $this;
    }
    /**
     * Add item to PvDatastoreItemDataWithParent value
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemDataWithParent $item
     * @return \ArrayType\ArrayOfPvDatastoreItemDataWithParent
     */
    public function addToPvDatastoreItemDataWithParent(\StructType\PvDatastoreItemDataWithParent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvDatastoreItemDataWithParent) {
            throw new \InvalidArgumentException(sprintf('The PvDatastoreItemDataWithParent property can only contain items of type \StructType\PvDatastoreItemDataWithParent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvDatastoreItemDataWithParent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvDatastoreItemDataWithParent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvDatastoreItemDataWithParent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvDatastoreItemDataWithParent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvDatastoreItemDataWithParent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvDatastoreItemDataWithParent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvDatastoreItemDataWithParent
     */
    public function getAttributeName()
    {
        return 'PvDatastoreItemDataWithParent';
    }
}
