<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvDatastoreItemData_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvDatastoreItemData_V2 extends AbstractStructArrayBase
{
    /**
     * The PvDatastoreItemData_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvDatastoreItemData_V2[]
     */
    public $PvDatastoreItemData_V2;
    /**
     * Constructor method for ArrayOfPvDatastoreItemData_V2
     * @uses ArrayOfPvDatastoreItemData_V2::setPvDatastoreItemData_V2()
     * @param \StructType\PvDatastoreItemData_V2[] $pvDatastoreItemData_V2
     */
    public function __construct(array $pvDatastoreItemData_V2 = array())
    {
        $this
            ->setPvDatastoreItemData_V2($pvDatastoreItemData_V2);
    }
    /**
     * Get PvDatastoreItemData_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvDatastoreItemData_V2[]|null
     */
    public function getPvDatastoreItemData_V2()
    {
        return isset($this->PvDatastoreItemData_V2) ? $this->PvDatastoreItemData_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvDatastoreItemData_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvDatastoreItemData_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvDatastoreItemData_V2ForArrayConstraintsFromSetPvDatastoreItemData_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvDatastoreItemData_V2PvDatastoreItemData_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPvDatastoreItemData_V2PvDatastoreItemData_V2Item instanceof \StructType\PvDatastoreItemData_V2) {
                $invalidValues[] = is_object($arrayOfPvDatastoreItemData_V2PvDatastoreItemData_V2Item) ? get_class($arrayOfPvDatastoreItemData_V2PvDatastoreItemData_V2Item) : sprintf('%s(%s)', gettype($arrayOfPvDatastoreItemData_V2PvDatastoreItemData_V2Item), var_export($arrayOfPvDatastoreItemData_V2PvDatastoreItemData_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvDatastoreItemData_V2 property can only contain items of type \StructType\PvDatastoreItemData_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvDatastoreItemData_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemData_V2[] $pvDatastoreItemData_V2
     * @return \ArrayType\ArrayOfPvDatastoreItemData_V2
     */
    public function setPvDatastoreItemData_V2(array $pvDatastoreItemData_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($pvDatastoreItemData_V2ArrayErrorMessage = self::validatePvDatastoreItemData_V2ForArrayConstraintsFromSetPvDatastoreItemData_V2($pvDatastoreItemData_V2))) {
            throw new \InvalidArgumentException($pvDatastoreItemData_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($pvDatastoreItemData_V2) || (is_array($pvDatastoreItemData_V2) && empty($pvDatastoreItemData_V2))) {
            unset($this->PvDatastoreItemData_V2);
        } else {
            $this->PvDatastoreItemData_V2 = $pvDatastoreItemData_V2;
        }
        return $this;
    }
    /**
     * Add item to PvDatastoreItemData_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemData_V2 $item
     * @return \ArrayType\ArrayOfPvDatastoreItemData_V2
     */
    public function addToPvDatastoreItemData_V2(\StructType\PvDatastoreItemData_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvDatastoreItemData_V2) {
            throw new \InvalidArgumentException(sprintf('The PvDatastoreItemData_V2 property can only contain items of type \StructType\PvDatastoreItemData_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvDatastoreItemData_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvDatastoreItemData_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvDatastoreItemData_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvDatastoreItemData_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvDatastoreItemData_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvDatastoreItemData_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvDatastoreItemData_V2
     */
    public function getAttributeName()
    {
        return 'PvDatastoreItemData_V2';
    }
}
