<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvDatastoreItemData_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvDatastoreItemData_V3 extends AbstractStructArrayBase
{
    /**
     * The PvDatastoreItemData_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvDatastoreItemData_V3[]
     */
    public $PvDatastoreItemData_V3;
    /**
     * Constructor method for ArrayOfPvDatastoreItemData_V3
     * @uses ArrayOfPvDatastoreItemData_V3::setPvDatastoreItemData_V3()
     * @param \StructType\PvDatastoreItemData_V3[] $pvDatastoreItemData_V3
     */
    public function __construct(array $pvDatastoreItemData_V3 = array())
    {
        $this
            ->setPvDatastoreItemData_V3($pvDatastoreItemData_V3);
    }
    /**
     * Get PvDatastoreItemData_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvDatastoreItemData_V3[]|null
     */
    public function getPvDatastoreItemData_V3()
    {
        return isset($this->PvDatastoreItemData_V3) ? $this->PvDatastoreItemData_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvDatastoreItemData_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvDatastoreItemData_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvDatastoreItemData_V3ForArrayConstraintsFromSetPvDatastoreItemData_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvDatastoreItemData_V3PvDatastoreItemData_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfPvDatastoreItemData_V3PvDatastoreItemData_V3Item instanceof \StructType\PvDatastoreItemData_V3) {
                $invalidValues[] = is_object($arrayOfPvDatastoreItemData_V3PvDatastoreItemData_V3Item) ? get_class($arrayOfPvDatastoreItemData_V3PvDatastoreItemData_V3Item) : sprintf('%s(%s)', gettype($arrayOfPvDatastoreItemData_V3PvDatastoreItemData_V3Item), var_export($arrayOfPvDatastoreItemData_V3PvDatastoreItemData_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvDatastoreItemData_V3 property can only contain items of type \StructType\PvDatastoreItemData_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvDatastoreItemData_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemData_V3[] $pvDatastoreItemData_V3
     * @return \ArrayType\ArrayOfPvDatastoreItemData_V3
     */
    public function setPvDatastoreItemData_V3(array $pvDatastoreItemData_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($pvDatastoreItemData_V3ArrayErrorMessage = self::validatePvDatastoreItemData_V3ForArrayConstraintsFromSetPvDatastoreItemData_V3($pvDatastoreItemData_V3))) {
            throw new \InvalidArgumentException($pvDatastoreItemData_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($pvDatastoreItemData_V3) || (is_array($pvDatastoreItemData_V3) && empty($pvDatastoreItemData_V3))) {
            unset($this->PvDatastoreItemData_V3);
        } else {
            $this->PvDatastoreItemData_V3 = $pvDatastoreItemData_V3;
        }
        return $this;
    }
    /**
     * Add item to PvDatastoreItemData_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\PvDatastoreItemData_V3 $item
     * @return \ArrayType\ArrayOfPvDatastoreItemData_V3
     */
    public function addToPvDatastoreItemData_V3(\StructType\PvDatastoreItemData_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvDatastoreItemData_V3) {
            throw new \InvalidArgumentException(sprintf('The PvDatastoreItemData_V3 property can only contain items of type \StructType\PvDatastoreItemData_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvDatastoreItemData_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvDatastoreItemData_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvDatastoreItemData_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvDatastoreItemData_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvDatastoreItemData_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvDatastoreItemData_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvDatastoreItemData_V3
     */
    public function getAttributeName()
    {
        return 'PvDatastoreItemData_V3';
    }
}
