<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvEntityTypeData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvEntityTypeData extends AbstractStructArrayBase
{
    /**
     * The PvEntityTypeData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvEntityTypeData[]
     */
    public $PvEntityTypeData;
    /**
     * Constructor method for ArrayOfPvEntityTypeData
     * @uses ArrayOfPvEntityTypeData::setPvEntityTypeData()
     * @param \StructType\PvEntityTypeData[] $pvEntityTypeData
     */
    public function __construct(array $pvEntityTypeData = array())
    {
        $this
            ->setPvEntityTypeData($pvEntityTypeData);
    }
    /**
     * Get PvEntityTypeData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvEntityTypeData[]|null
     */
    public function getPvEntityTypeData()
    {
        return isset($this->PvEntityTypeData) ? $this->PvEntityTypeData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvEntityTypeData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvEntityTypeData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvEntityTypeDataForArrayConstraintsFromSetPvEntityTypeData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvEntityTypeDataPvEntityTypeDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvEntityTypeDataPvEntityTypeDataItem instanceof \StructType\PvEntityTypeData) {
                $invalidValues[] = is_object($arrayOfPvEntityTypeDataPvEntityTypeDataItem) ? get_class($arrayOfPvEntityTypeDataPvEntityTypeDataItem) : sprintf('%s(%s)', gettype($arrayOfPvEntityTypeDataPvEntityTypeDataItem), var_export($arrayOfPvEntityTypeDataPvEntityTypeDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvEntityTypeData property can only contain items of type \StructType\PvEntityTypeData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvEntityTypeData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvEntityTypeData[] $pvEntityTypeData
     * @return \ArrayType\ArrayOfPvEntityTypeData
     */
    public function setPvEntityTypeData(array $pvEntityTypeData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvEntityTypeDataArrayErrorMessage = self::validatePvEntityTypeDataForArrayConstraintsFromSetPvEntityTypeData($pvEntityTypeData))) {
            throw new \InvalidArgumentException($pvEntityTypeDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvEntityTypeData) || (is_array($pvEntityTypeData) && empty($pvEntityTypeData))) {
            unset($this->PvEntityTypeData);
        } else {
            $this->PvEntityTypeData = $pvEntityTypeData;
        }
        return $this;
    }
    /**
     * Add item to PvEntityTypeData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvEntityTypeData $item
     * @return \ArrayType\ArrayOfPvEntityTypeData
     */
    public function addToPvEntityTypeData(\StructType\PvEntityTypeData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvEntityTypeData) {
            throw new \InvalidArgumentException(sprintf('The PvEntityTypeData property can only contain items of type \StructType\PvEntityTypeData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvEntityTypeData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvEntityTypeData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvEntityTypeData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvEntityTypeData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvEntityTypeData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvEntityTypeData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvEntityTypeData
     */
    public function getAttributeName()
    {
        return 'PvEntityTypeData';
    }
}
