<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvEnumerationItemData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvEnumerationItemData extends AbstractStructArrayBase
{
    /**
     * The PvEnumerationItemData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvEnumerationItemData[]
     */
    public $PvEnumerationItemData;
    /**
     * Constructor method for ArrayOfPvEnumerationItemData
     * @uses ArrayOfPvEnumerationItemData::setPvEnumerationItemData()
     * @param \StructType\PvEnumerationItemData[] $pvEnumerationItemData
     */
    public function __construct(array $pvEnumerationItemData = array())
    {
        $this
            ->setPvEnumerationItemData($pvEnumerationItemData);
    }
    /**
     * Get PvEnumerationItemData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvEnumerationItemData[]|null
     */
    public function getPvEnumerationItemData()
    {
        return isset($this->PvEnumerationItemData) ? $this->PvEnumerationItemData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvEnumerationItemData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvEnumerationItemData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvEnumerationItemDataForArrayConstraintsFromSetPvEnumerationItemData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvEnumerationItemDataPvEnumerationItemDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvEnumerationItemDataPvEnumerationItemDataItem instanceof \StructType\PvEnumerationItemData) {
                $invalidValues[] = is_object($arrayOfPvEnumerationItemDataPvEnumerationItemDataItem) ? get_class($arrayOfPvEnumerationItemDataPvEnumerationItemDataItem) : sprintf('%s(%s)', gettype($arrayOfPvEnumerationItemDataPvEnumerationItemDataItem), var_export($arrayOfPvEnumerationItemDataPvEnumerationItemDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvEnumerationItemData property can only contain items of type \StructType\PvEnumerationItemData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvEnumerationItemData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvEnumerationItemData[] $pvEnumerationItemData
     * @return \ArrayType\ArrayOfPvEnumerationItemData
     */
    public function setPvEnumerationItemData(array $pvEnumerationItemData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvEnumerationItemDataArrayErrorMessage = self::validatePvEnumerationItemDataForArrayConstraintsFromSetPvEnumerationItemData($pvEnumerationItemData))) {
            throw new \InvalidArgumentException($pvEnumerationItemDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvEnumerationItemData) || (is_array($pvEnumerationItemData) && empty($pvEnumerationItemData))) {
            unset($this->PvEnumerationItemData);
        } else {
            $this->PvEnumerationItemData = $pvEnumerationItemData;
        }
        return $this;
    }
    /**
     * Add item to PvEnumerationItemData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvEnumerationItemData $item
     * @return \ArrayType\ArrayOfPvEnumerationItemData
     */
    public function addToPvEnumerationItemData(\StructType\PvEnumerationItemData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvEnumerationItemData) {
            throw new \InvalidArgumentException(sprintf('The PvEnumerationItemData property can only contain items of type \StructType\PvEnumerationItemData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvEnumerationItemData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvEnumerationItemData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvEnumerationItemData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvEnumerationItemData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvEnumerationItemData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvEnumerationItemData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvEnumerationItemData
     */
    public function getAttributeName()
    {
        return 'PvEnumerationItemData';
    }
}
