<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvFieldData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvFieldData extends AbstractStructArrayBase
{
    /**
     * The PvFieldData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvFieldData[]
     */
    public $PvFieldData;
    /**
     * Constructor method for ArrayOfPvFieldData
     * @uses ArrayOfPvFieldData::setPvFieldData()
     * @param \StructType\PvFieldData[] $pvFieldData
     */
    public function __construct(array $pvFieldData = array())
    {
        $this
            ->setPvFieldData($pvFieldData);
    }
    /**
     * Get PvFieldData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvFieldData[]|null
     */
    public function getPvFieldData()
    {
        return isset($this->PvFieldData) ? $this->PvFieldData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvFieldData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvFieldData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvFieldDataForArrayConstraintsFromSetPvFieldData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvFieldDataPvFieldDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvFieldDataPvFieldDataItem instanceof \StructType\PvFieldData) {
                $invalidValues[] = is_object($arrayOfPvFieldDataPvFieldDataItem) ? get_class($arrayOfPvFieldDataPvFieldDataItem) : sprintf('%s(%s)', gettype($arrayOfPvFieldDataPvFieldDataItem), var_export($arrayOfPvFieldDataPvFieldDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvFieldData property can only contain items of type \StructType\PvFieldData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvFieldData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvFieldData[] $pvFieldData
     * @return \ArrayType\ArrayOfPvFieldData
     */
    public function setPvFieldData(array $pvFieldData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvFieldDataArrayErrorMessage = self::validatePvFieldDataForArrayConstraintsFromSetPvFieldData($pvFieldData))) {
            throw new \InvalidArgumentException($pvFieldDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvFieldData) || (is_array($pvFieldData) && empty($pvFieldData))) {
            unset($this->PvFieldData);
        } else {
            $this->PvFieldData = $pvFieldData;
        }
        return $this;
    }
    /**
     * Add item to PvFieldData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvFieldData $item
     * @return \ArrayType\ArrayOfPvFieldData
     */
    public function addToPvFieldData(\StructType\PvFieldData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvFieldData) {
            throw new \InvalidArgumentException(sprintf('The PvFieldData property can only contain items of type \StructType\PvFieldData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvFieldData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvFieldData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvFieldData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvFieldData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvFieldData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvFieldData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvFieldData
     */
    public function getAttributeName()
    {
        return 'PvFieldData';
    }
}
