<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvFieldValueData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvFieldValueData extends AbstractStructArrayBase
{
    /**
     * The PvFieldValueData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvFieldValueData[]
     */
    public $PvFieldValueData;
    /**
     * Constructor method for ArrayOfPvFieldValueData
     * @uses ArrayOfPvFieldValueData::setPvFieldValueData()
     * @param \StructType\PvFieldValueData[] $pvFieldValueData
     */
    public function __construct(array $pvFieldValueData = array())
    {
        $this
            ->setPvFieldValueData($pvFieldValueData);
    }
    /**
     * Get PvFieldValueData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvFieldValueData[]|null
     */
    public function getPvFieldValueData()
    {
        return isset($this->PvFieldValueData) ? $this->PvFieldValueData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvFieldValueData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvFieldValueData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvFieldValueDataForArrayConstraintsFromSetPvFieldValueData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvFieldValueDataPvFieldValueDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvFieldValueDataPvFieldValueDataItem instanceof \StructType\PvFieldValueData) {
                $invalidValues[] = is_object($arrayOfPvFieldValueDataPvFieldValueDataItem) ? get_class($arrayOfPvFieldValueDataPvFieldValueDataItem) : sprintf('%s(%s)', gettype($arrayOfPvFieldValueDataPvFieldValueDataItem), var_export($arrayOfPvFieldValueDataPvFieldValueDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvFieldValueData property can only contain items of type \StructType\PvFieldValueData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvFieldValueData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvFieldValueData[] $pvFieldValueData
     * @return \ArrayType\ArrayOfPvFieldValueData
     */
    public function setPvFieldValueData(array $pvFieldValueData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvFieldValueDataArrayErrorMessage = self::validatePvFieldValueDataForArrayConstraintsFromSetPvFieldValueData($pvFieldValueData))) {
            throw new \InvalidArgumentException($pvFieldValueDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvFieldValueData) || (is_array($pvFieldValueData) && empty($pvFieldValueData))) {
            unset($this->PvFieldValueData);
        } else {
            $this->PvFieldValueData = $pvFieldValueData;
        }
        return $this;
    }
    /**
     * Add item to PvFieldValueData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvFieldValueData $item
     * @return \ArrayType\ArrayOfPvFieldValueData
     */
    public function addToPvFieldValueData(\StructType\PvFieldValueData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvFieldValueData) {
            throw new \InvalidArgumentException(sprintf('The PvFieldValueData property can only contain items of type \StructType\PvFieldValueData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvFieldValueData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvFieldValueData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvFieldValueData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvFieldValueData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvFieldValueData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvFieldValueData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvFieldValueData
     */
    public function getAttributeName()
    {
        return 'PvFieldValueData';
    }
}
