<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvLineData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvLineData extends AbstractStructArrayBase
{
    /**
     * The PvLineData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvLineData[]
     */
    public $PvLineData;
    /**
     * Constructor method for ArrayOfPvLineData
     * @uses ArrayOfPvLineData::setPvLineData()
     * @param \StructType\PvLineData[] $pvLineData
     */
    public function __construct(array $pvLineData = array())
    {
        $this
            ->setPvLineData($pvLineData);
    }
    /**
     * Get PvLineData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvLineData[]|null
     */
    public function getPvLineData()
    {
        return isset($this->PvLineData) ? $this->PvLineData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvLineData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvLineData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvLineDataForArrayConstraintsFromSetPvLineData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvLineDataPvLineDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvLineDataPvLineDataItem instanceof \StructType\PvLineData) {
                $invalidValues[] = is_object($arrayOfPvLineDataPvLineDataItem) ? get_class($arrayOfPvLineDataPvLineDataItem) : sprintf('%s(%s)', gettype($arrayOfPvLineDataPvLineDataItem), var_export($arrayOfPvLineDataPvLineDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvLineData property can only contain items of type \StructType\PvLineData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvLineData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvLineData[] $pvLineData
     * @return \ArrayType\ArrayOfPvLineData
     */
    public function setPvLineData(array $pvLineData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvLineDataArrayErrorMessage = self::validatePvLineDataForArrayConstraintsFromSetPvLineData($pvLineData))) {
            throw new \InvalidArgumentException($pvLineDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvLineData) || (is_array($pvLineData) && empty($pvLineData))) {
            unset($this->PvLineData);
        } else {
            $this->PvLineData = $pvLineData;
        }
        return $this;
    }
    /**
     * Add item to PvLineData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvLineData $item
     * @return \ArrayType\ArrayOfPvLineData
     */
    public function addToPvLineData(\StructType\PvLineData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvLineData) {
            throw new \InvalidArgumentException(sprintf('The PvLineData property can only contain items of type \StructType\PvLineData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvLineData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvLineData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvLineData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvLineData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvLineData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvLineData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvLineData
     */
    public function getAttributeName()
    {
        return 'PvLineData';
    }
}
