<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvMarkDataV2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvMarkDataV2 extends AbstractStructArrayBase
{
    /**
     * The PvMarkDataV2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvMarkDataV2[]
     */
    public $PvMarkDataV2;
    /**
     * Constructor method for ArrayOfPvMarkDataV2
     * @uses ArrayOfPvMarkDataV2::setPvMarkDataV2()
     * @param \StructType\PvMarkDataV2[] $pvMarkDataV2
     */
    public function __construct(array $pvMarkDataV2 = array())
    {
        $this
            ->setPvMarkDataV2($pvMarkDataV2);
    }
    /**
     * Get PvMarkDataV2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvMarkDataV2[]|null
     */
    public function getPvMarkDataV2()
    {
        return isset($this->PvMarkDataV2) ? $this->PvMarkDataV2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvMarkDataV2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvMarkDataV2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvMarkDataV2ForArrayConstraintsFromSetPvMarkDataV2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvMarkDataV2PvMarkDataV2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPvMarkDataV2PvMarkDataV2Item instanceof \StructType\PvMarkDataV2) {
                $invalidValues[] = is_object($arrayOfPvMarkDataV2PvMarkDataV2Item) ? get_class($arrayOfPvMarkDataV2PvMarkDataV2Item) : sprintf('%s(%s)', gettype($arrayOfPvMarkDataV2PvMarkDataV2Item), var_export($arrayOfPvMarkDataV2PvMarkDataV2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvMarkDataV2 property can only contain items of type \StructType\PvMarkDataV2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvMarkDataV2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvMarkDataV2[] $pvMarkDataV2
     * @return \ArrayType\ArrayOfPvMarkDataV2
     */
    public function setPvMarkDataV2(array $pvMarkDataV2 = array())
    {
        // validation for constraint: array
        if ('' !== ($pvMarkDataV2ArrayErrorMessage = self::validatePvMarkDataV2ForArrayConstraintsFromSetPvMarkDataV2($pvMarkDataV2))) {
            throw new \InvalidArgumentException($pvMarkDataV2ArrayErrorMessage, __LINE__);
        }
        if (is_null($pvMarkDataV2) || (is_array($pvMarkDataV2) && empty($pvMarkDataV2))) {
            unset($this->PvMarkDataV2);
        } else {
            $this->PvMarkDataV2 = $pvMarkDataV2;
        }
        return $this;
    }
    /**
     * Add item to PvMarkDataV2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PvMarkDataV2 $item
     * @return \ArrayType\ArrayOfPvMarkDataV2
     */
    public function addToPvMarkDataV2(\StructType\PvMarkDataV2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvMarkDataV2) {
            throw new \InvalidArgumentException(sprintf('The PvMarkDataV2 property can only contain items of type \StructType\PvMarkDataV2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvMarkDataV2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvMarkDataV2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvMarkDataV2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvMarkDataV2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvMarkDataV2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvMarkDataV2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvMarkDataV2
     */
    public function getAttributeName()
    {
        return 'PvMarkDataV2';
    }
}
