<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvNoteData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvNoteData extends AbstractStructArrayBase
{
    /**
     * The PvNoteData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvNoteData[]
     */
    public $PvNoteData;
    /**
     * Constructor method for ArrayOfPvNoteData
     * @uses ArrayOfPvNoteData::setPvNoteData()
     * @param \StructType\PvNoteData[] $pvNoteData
     */
    public function __construct(array $pvNoteData = array())
    {
        $this
            ->setPvNoteData($pvNoteData);
    }
    /**
     * Get PvNoteData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvNoteData[]|null
     */
    public function getPvNoteData()
    {
        return isset($this->PvNoteData) ? $this->PvNoteData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvNoteData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvNoteData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvNoteDataForArrayConstraintsFromSetPvNoteData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvNoteDataPvNoteDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvNoteDataPvNoteDataItem instanceof \StructType\PvNoteData) {
                $invalidValues[] = is_object($arrayOfPvNoteDataPvNoteDataItem) ? get_class($arrayOfPvNoteDataPvNoteDataItem) : sprintf('%s(%s)', gettype($arrayOfPvNoteDataPvNoteDataItem), var_export($arrayOfPvNoteDataPvNoteDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvNoteData property can only contain items of type \StructType\PvNoteData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvNoteData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvNoteData[] $pvNoteData
     * @return \ArrayType\ArrayOfPvNoteData
     */
    public function setPvNoteData(array $pvNoteData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvNoteDataArrayErrorMessage = self::validatePvNoteDataForArrayConstraintsFromSetPvNoteData($pvNoteData))) {
            throw new \InvalidArgumentException($pvNoteDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvNoteData) || (is_array($pvNoteData) && empty($pvNoteData))) {
            unset($this->PvNoteData);
        } else {
            $this->PvNoteData = $pvNoteData;
        }
        return $this;
    }
    /**
     * Add item to PvNoteData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvNoteData $item
     * @return \ArrayType\ArrayOfPvNoteData
     */
    public function addToPvNoteData(\StructType\PvNoteData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvNoteData) {
            throw new \InvalidArgumentException(sprintf('The PvNoteData property can only contain items of type \StructType\PvNoteData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvNoteData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvNoteData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvNoteData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvNoteData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvNoteData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvNoteData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvNoteData
     */
    public function getAttributeName()
    {
        return 'PvNoteData';
    }
}
