<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvProductData_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvProductData_V2 extends AbstractStructArrayBase
{
    /**
     * The PvProductData_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvProductData_V2[]
     */
    public $PvProductData_V2;
    /**
     * Constructor method for ArrayOfPvProductData_V2
     * @uses ArrayOfPvProductData_V2::setPvProductData_V2()
     * @param \StructType\PvProductData_V2[] $pvProductData_V2
     */
    public function __construct(array $pvProductData_V2 = array())
    {
        $this
            ->setPvProductData_V2($pvProductData_V2);
    }
    /**
     * Get PvProductData_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvProductData_V2[]|null
     */
    public function getPvProductData_V2()
    {
        return isset($this->PvProductData_V2) ? $this->PvProductData_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvProductData_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvProductData_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvProductData_V2ForArrayConstraintsFromSetPvProductData_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvProductData_V2PvProductData_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPvProductData_V2PvProductData_V2Item instanceof \StructType\PvProductData_V2) {
                $invalidValues[] = is_object($arrayOfPvProductData_V2PvProductData_V2Item) ? get_class($arrayOfPvProductData_V2PvProductData_V2Item) : sprintf('%s(%s)', gettype($arrayOfPvProductData_V2PvProductData_V2Item), var_export($arrayOfPvProductData_V2PvProductData_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvProductData_V2 property can only contain items of type \StructType\PvProductData_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvProductData_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvProductData_V2[] $pvProductData_V2
     * @return \ArrayType\ArrayOfPvProductData_V2
     */
    public function setPvProductData_V2(array $pvProductData_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($pvProductData_V2ArrayErrorMessage = self::validatePvProductData_V2ForArrayConstraintsFromSetPvProductData_V2($pvProductData_V2))) {
            throw new \InvalidArgumentException($pvProductData_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($pvProductData_V2) || (is_array($pvProductData_V2) && empty($pvProductData_V2))) {
            unset($this->PvProductData_V2);
        } else {
            $this->PvProductData_V2 = $pvProductData_V2;
        }
        return $this;
    }
    /**
     * Add item to PvProductData_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PvProductData_V2 $item
     * @return \ArrayType\ArrayOfPvProductData_V2
     */
    public function addToPvProductData_V2(\StructType\PvProductData_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvProductData_V2) {
            throw new \InvalidArgumentException(sprintf('The PvProductData_V2 property can only contain items of type \StructType\PvProductData_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvProductData_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvProductData_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvProductData_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvProductData_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvProductData_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvProductData_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvProductData_V2
     */
    public function getAttributeName()
    {
        return 'PvProductData_V2';
    }
}
