<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvProductGroupData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvProductGroupData extends AbstractStructArrayBase
{
    /**
     * The PvProductGroupData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvProductGroupData[]
     */
    public $PvProductGroupData;
    /**
     * Constructor method for ArrayOfPvProductGroupData
     * @uses ArrayOfPvProductGroupData::setPvProductGroupData()
     * @param \StructType\PvProductGroupData[] $pvProductGroupData
     */
    public function __construct(array $pvProductGroupData = array())
    {
        $this
            ->setPvProductGroupData($pvProductGroupData);
    }
    /**
     * Get PvProductGroupData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvProductGroupData[]|null
     */
    public function getPvProductGroupData()
    {
        return isset($this->PvProductGroupData) ? $this->PvProductGroupData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvProductGroupData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvProductGroupData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvProductGroupDataForArrayConstraintsFromSetPvProductGroupData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvProductGroupDataPvProductGroupDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvProductGroupDataPvProductGroupDataItem instanceof \StructType\PvProductGroupData) {
                $invalidValues[] = is_object($arrayOfPvProductGroupDataPvProductGroupDataItem) ? get_class($arrayOfPvProductGroupDataPvProductGroupDataItem) : sprintf('%s(%s)', gettype($arrayOfPvProductGroupDataPvProductGroupDataItem), var_export($arrayOfPvProductGroupDataPvProductGroupDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvProductGroupData property can only contain items of type \StructType\PvProductGroupData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvProductGroupData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvProductGroupData[] $pvProductGroupData
     * @return \ArrayType\ArrayOfPvProductGroupData
     */
    public function setPvProductGroupData(array $pvProductGroupData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvProductGroupDataArrayErrorMessage = self::validatePvProductGroupDataForArrayConstraintsFromSetPvProductGroupData($pvProductGroupData))) {
            throw new \InvalidArgumentException($pvProductGroupDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvProductGroupData) || (is_array($pvProductGroupData) && empty($pvProductGroupData))) {
            unset($this->PvProductGroupData);
        } else {
            $this->PvProductGroupData = $pvProductGroupData;
        }
        return $this;
    }
    /**
     * Add item to PvProductGroupData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvProductGroupData $item
     * @return \ArrayType\ArrayOfPvProductGroupData
     */
    public function addToPvProductGroupData(\StructType\PvProductGroupData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvProductGroupData) {
            throw new \InvalidArgumentException(sprintf('The PvProductGroupData property can only contain items of type \StructType\PvProductGroupData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvProductGroupData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvProductGroupData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvProductGroupData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvProductGroupData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvProductGroupData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvProductGroupData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvProductGroupData
     */
    public function getAttributeName()
    {
        return 'PvProductGroupData';
    }
}
