<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvProductLineData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvProductLineData extends AbstractStructArrayBase
{
    /**
     * The PvProductLineData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvProductLineData[]
     */
    public $PvProductLineData;
    /**
     * Constructor method for ArrayOfPvProductLineData
     * @uses ArrayOfPvProductLineData::setPvProductLineData()
     * @param \StructType\PvProductLineData[] $pvProductLineData
     */
    public function __construct(array $pvProductLineData = array())
    {
        $this
            ->setPvProductLineData($pvProductLineData);
    }
    /**
     * Get PvProductLineData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvProductLineData[]|null
     */
    public function getPvProductLineData()
    {
        return isset($this->PvProductLineData) ? $this->PvProductLineData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvProductLineData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvProductLineData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvProductLineDataForArrayConstraintsFromSetPvProductLineData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvProductLineDataPvProductLineDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvProductLineDataPvProductLineDataItem instanceof \StructType\PvProductLineData) {
                $invalidValues[] = is_object($arrayOfPvProductLineDataPvProductLineDataItem) ? get_class($arrayOfPvProductLineDataPvProductLineDataItem) : sprintf('%s(%s)', gettype($arrayOfPvProductLineDataPvProductLineDataItem), var_export($arrayOfPvProductLineDataPvProductLineDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvProductLineData property can only contain items of type \StructType\PvProductLineData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvProductLineData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvProductLineData[] $pvProductLineData
     * @return \ArrayType\ArrayOfPvProductLineData
     */
    public function setPvProductLineData(array $pvProductLineData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvProductLineDataArrayErrorMessage = self::validatePvProductLineDataForArrayConstraintsFromSetPvProductLineData($pvProductLineData))) {
            throw new \InvalidArgumentException($pvProductLineDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvProductLineData) || (is_array($pvProductLineData) && empty($pvProductLineData))) {
            unset($this->PvProductLineData);
        } else {
            $this->PvProductLineData = $pvProductLineData;
        }
        return $this;
    }
    /**
     * Add item to PvProductLineData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvProductLineData $item
     * @return \ArrayType\ArrayOfPvProductLineData
     */
    public function addToPvProductLineData(\StructType\PvProductLineData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvProductLineData) {
            throw new \InvalidArgumentException(sprintf('The PvProductLineData property can only contain items of type \StructType\PvProductLineData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvProductLineData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvProductLineData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvProductLineData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvProductLineData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvProductLineData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvProductLineData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvProductLineData
     */
    public function getAttributeName()
    {
        return 'PvProductLineData';
    }
}
