<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvQueueData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvQueueData extends AbstractStructArrayBase
{
    /**
     * The PvQueueData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvQueueData[]
     */
    public $PvQueueData;
    /**
     * Constructor method for ArrayOfPvQueueData
     * @uses ArrayOfPvQueueData::setPvQueueData()
     * @param \StructType\PvQueueData[] $pvQueueData
     */
    public function __construct(array $pvQueueData = array())
    {
        $this
            ->setPvQueueData($pvQueueData);
    }
    /**
     * Get PvQueueData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvQueueData[]|null
     */
    public function getPvQueueData()
    {
        return isset($this->PvQueueData) ? $this->PvQueueData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvQueueData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvQueueData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvQueueDataForArrayConstraintsFromSetPvQueueData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvQueueDataPvQueueDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvQueueDataPvQueueDataItem instanceof \StructType\PvQueueData) {
                $invalidValues[] = is_object($arrayOfPvQueueDataPvQueueDataItem) ? get_class($arrayOfPvQueueDataPvQueueDataItem) : sprintf('%s(%s)', gettype($arrayOfPvQueueDataPvQueueDataItem), var_export($arrayOfPvQueueDataPvQueueDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvQueueData property can only contain items of type \StructType\PvQueueData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvQueueData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvQueueData[] $pvQueueData
     * @return \ArrayType\ArrayOfPvQueueData
     */
    public function setPvQueueData(array $pvQueueData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvQueueDataArrayErrorMessage = self::validatePvQueueDataForArrayConstraintsFromSetPvQueueData($pvQueueData))) {
            throw new \InvalidArgumentException($pvQueueDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvQueueData) || (is_array($pvQueueData) && empty($pvQueueData))) {
            unset($this->PvQueueData);
        } else {
            $this->PvQueueData = $pvQueueData;
        }
        return $this;
    }
    /**
     * Add item to PvQueueData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvQueueData $item
     * @return \ArrayType\ArrayOfPvQueueData
     */
    public function addToPvQueueData(\StructType\PvQueueData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvQueueData) {
            throw new \InvalidArgumentException(sprintf('The PvQueueData property can only contain items of type \StructType\PvQueueData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvQueueData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvQueueData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvQueueData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvQueueData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvQueueData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvQueueData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvQueueData
     */
    public function getAttributeName()
    {
        return 'PvQueueData';
    }
}
