<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvRelationshipData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvRelationshipData extends AbstractStructArrayBase
{
    /**
     * The PvRelationshipData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvRelationshipData[]
     */
    public $PvRelationshipData;
    /**
     * Constructor method for ArrayOfPvRelationshipData
     * @uses ArrayOfPvRelationshipData::setPvRelationshipData()
     * @param \StructType\PvRelationshipData[] $pvRelationshipData
     */
    public function __construct(array $pvRelationshipData = array())
    {
        $this
            ->setPvRelationshipData($pvRelationshipData);
    }
    /**
     * Get PvRelationshipData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvRelationshipData[]|null
     */
    public function getPvRelationshipData()
    {
        return isset($this->PvRelationshipData) ? $this->PvRelationshipData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvRelationshipData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvRelationshipData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvRelationshipDataForArrayConstraintsFromSetPvRelationshipData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvRelationshipDataPvRelationshipDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvRelationshipDataPvRelationshipDataItem instanceof \StructType\PvRelationshipData) {
                $invalidValues[] = is_object($arrayOfPvRelationshipDataPvRelationshipDataItem) ? get_class($arrayOfPvRelationshipDataPvRelationshipDataItem) : sprintf('%s(%s)', gettype($arrayOfPvRelationshipDataPvRelationshipDataItem), var_export($arrayOfPvRelationshipDataPvRelationshipDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvRelationshipData property can only contain items of type \StructType\PvRelationshipData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvRelationshipData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvRelationshipData[] $pvRelationshipData
     * @return \ArrayType\ArrayOfPvRelationshipData
     */
    public function setPvRelationshipData(array $pvRelationshipData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvRelationshipDataArrayErrorMessage = self::validatePvRelationshipDataForArrayConstraintsFromSetPvRelationshipData($pvRelationshipData))) {
            throw new \InvalidArgumentException($pvRelationshipDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvRelationshipData) || (is_array($pvRelationshipData) && empty($pvRelationshipData))) {
            unset($this->PvRelationshipData);
        } else {
            $this->PvRelationshipData = $pvRelationshipData;
        }
        return $this;
    }
    /**
     * Add item to PvRelationshipData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvRelationshipData $item
     * @return \ArrayType\ArrayOfPvRelationshipData
     */
    public function addToPvRelationshipData(\StructType\PvRelationshipData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvRelationshipData) {
            throw new \InvalidArgumentException(sprintf('The PvRelationshipData property can only contain items of type \StructType\PvRelationshipData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvRelationshipData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvRelationshipData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvRelationshipData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvRelationshipData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvRelationshipData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvRelationshipData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvRelationshipData
     */
    public function getAttributeName()
    {
        return 'PvRelationshipData';
    }
}
