<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvRelationshipMarkData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvRelationshipMarkData extends AbstractStructArrayBase
{
    /**
     * The PvRelationshipMarkData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvRelationshipMarkData[]
     */
    public $PvRelationshipMarkData;
    /**
     * Constructor method for ArrayOfPvRelationshipMarkData
     * @uses ArrayOfPvRelationshipMarkData::setPvRelationshipMarkData()
     * @param \StructType\PvRelationshipMarkData[] $pvRelationshipMarkData
     */
    public function __construct(array $pvRelationshipMarkData = array())
    {
        $this
            ->setPvRelationshipMarkData($pvRelationshipMarkData);
    }
    /**
     * Get PvRelationshipMarkData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvRelationshipMarkData[]|null
     */
    public function getPvRelationshipMarkData()
    {
        return isset($this->PvRelationshipMarkData) ? $this->PvRelationshipMarkData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvRelationshipMarkData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvRelationshipMarkData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvRelationshipMarkDataForArrayConstraintsFromSetPvRelationshipMarkData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvRelationshipMarkDataPvRelationshipMarkDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvRelationshipMarkDataPvRelationshipMarkDataItem instanceof \StructType\PvRelationshipMarkData) {
                $invalidValues[] = is_object($arrayOfPvRelationshipMarkDataPvRelationshipMarkDataItem) ? get_class($arrayOfPvRelationshipMarkDataPvRelationshipMarkDataItem) : sprintf('%s(%s)', gettype($arrayOfPvRelationshipMarkDataPvRelationshipMarkDataItem), var_export($arrayOfPvRelationshipMarkDataPvRelationshipMarkDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvRelationshipMarkData property can only contain items of type \StructType\PvRelationshipMarkData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvRelationshipMarkData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvRelationshipMarkData[] $pvRelationshipMarkData
     * @return \ArrayType\ArrayOfPvRelationshipMarkData
     */
    public function setPvRelationshipMarkData(array $pvRelationshipMarkData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvRelationshipMarkDataArrayErrorMessage = self::validatePvRelationshipMarkDataForArrayConstraintsFromSetPvRelationshipMarkData($pvRelationshipMarkData))) {
            throw new \InvalidArgumentException($pvRelationshipMarkDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvRelationshipMarkData) || (is_array($pvRelationshipMarkData) && empty($pvRelationshipMarkData))) {
            unset($this->PvRelationshipMarkData);
        } else {
            $this->PvRelationshipMarkData = $pvRelationshipMarkData;
        }
        return $this;
    }
    /**
     * Add item to PvRelationshipMarkData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvRelationshipMarkData $item
     * @return \ArrayType\ArrayOfPvRelationshipMarkData
     */
    public function addToPvRelationshipMarkData(\StructType\PvRelationshipMarkData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvRelationshipMarkData) {
            throw new \InvalidArgumentException(sprintf('The PvRelationshipMarkData property can only contain items of type \StructType\PvRelationshipMarkData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvRelationshipMarkData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvRelationshipMarkData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvRelationshipMarkData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvRelationshipMarkData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvRelationshipMarkData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvRelationshipMarkData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvRelationshipMarkData
     */
    public function getAttributeName()
    {
        return 'PvRelationshipMarkData';
    }
}
