<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvRelationshipMarkDataCompact ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvRelationshipMarkDataCompact extends AbstractStructArrayBase
{
    /**
     * The PvRelationshipMarkDataCompact
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvRelationshipMarkDataCompact[]
     */
    public $PvRelationshipMarkDataCompact;
    /**
     * Constructor method for ArrayOfPvRelationshipMarkDataCompact
     * @uses ArrayOfPvRelationshipMarkDataCompact::setPvRelationshipMarkDataCompact()
     * @param \StructType\PvRelationshipMarkDataCompact[] $pvRelationshipMarkDataCompact
     */
    public function __construct(array $pvRelationshipMarkDataCompact = array())
    {
        $this
            ->setPvRelationshipMarkDataCompact($pvRelationshipMarkDataCompact);
    }
    /**
     * Get PvRelationshipMarkDataCompact value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvRelationshipMarkDataCompact[]|null
     */
    public function getPvRelationshipMarkDataCompact()
    {
        return isset($this->PvRelationshipMarkDataCompact) ? $this->PvRelationshipMarkDataCompact : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvRelationshipMarkDataCompact method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvRelationshipMarkDataCompact method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvRelationshipMarkDataCompactForArrayConstraintsFromSetPvRelationshipMarkDataCompact(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvRelationshipMarkDataCompactPvRelationshipMarkDataCompactItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvRelationshipMarkDataCompactPvRelationshipMarkDataCompactItem instanceof \StructType\PvRelationshipMarkDataCompact) {
                $invalidValues[] = is_object($arrayOfPvRelationshipMarkDataCompactPvRelationshipMarkDataCompactItem) ? get_class($arrayOfPvRelationshipMarkDataCompactPvRelationshipMarkDataCompactItem) : sprintf('%s(%s)', gettype($arrayOfPvRelationshipMarkDataCompactPvRelationshipMarkDataCompactItem), var_export($arrayOfPvRelationshipMarkDataCompactPvRelationshipMarkDataCompactItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvRelationshipMarkDataCompact property can only contain items of type \StructType\PvRelationshipMarkDataCompact, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvRelationshipMarkDataCompact value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvRelationshipMarkDataCompact[] $pvRelationshipMarkDataCompact
     * @return \ArrayType\ArrayOfPvRelationshipMarkDataCompact
     */
    public function setPvRelationshipMarkDataCompact(array $pvRelationshipMarkDataCompact = array())
    {
        // validation for constraint: array
        if ('' !== ($pvRelationshipMarkDataCompactArrayErrorMessage = self::validatePvRelationshipMarkDataCompactForArrayConstraintsFromSetPvRelationshipMarkDataCompact($pvRelationshipMarkDataCompact))) {
            throw new \InvalidArgumentException($pvRelationshipMarkDataCompactArrayErrorMessage, __LINE__);
        }
        if (is_null($pvRelationshipMarkDataCompact) || (is_array($pvRelationshipMarkDataCompact) && empty($pvRelationshipMarkDataCompact))) {
            unset($this->PvRelationshipMarkDataCompact);
        } else {
            $this->PvRelationshipMarkDataCompact = $pvRelationshipMarkDataCompact;
        }
        return $this;
    }
    /**
     * Add item to PvRelationshipMarkDataCompact value
     * @throws \InvalidArgumentException
     * @param \StructType\PvRelationshipMarkDataCompact $item
     * @return \ArrayType\ArrayOfPvRelationshipMarkDataCompact
     */
    public function addToPvRelationshipMarkDataCompact(\StructType\PvRelationshipMarkDataCompact $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvRelationshipMarkDataCompact) {
            throw new \InvalidArgumentException(sprintf('The PvRelationshipMarkDataCompact property can only contain items of type \StructType\PvRelationshipMarkDataCompact, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvRelationshipMarkDataCompact[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvRelationshipMarkDataCompact|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvRelationshipMarkDataCompact|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvRelationshipMarkDataCompact|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvRelationshipMarkDataCompact|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvRelationshipMarkDataCompact|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvRelationshipMarkDataCompact
     */
    public function getAttributeName()
    {
        return 'PvRelationshipMarkDataCompact';
    }
}
