<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvRoleData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvRoleData extends AbstractStructArrayBase
{
    /**
     * The PvRoleData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvRoleData[]
     */
    public $PvRoleData;
    /**
     * Constructor method for ArrayOfPvRoleData
     * @uses ArrayOfPvRoleData::setPvRoleData()
     * @param \StructType\PvRoleData[] $pvRoleData
     */
    public function __construct(array $pvRoleData = array())
    {
        $this
            ->setPvRoleData($pvRoleData);
    }
    /**
     * Get PvRoleData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvRoleData[]|null
     */
    public function getPvRoleData()
    {
        return isset($this->PvRoleData) ? $this->PvRoleData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvRoleData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvRoleData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvRoleDataForArrayConstraintsFromSetPvRoleData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvRoleDataPvRoleDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvRoleDataPvRoleDataItem instanceof \StructType\PvRoleData) {
                $invalidValues[] = is_object($arrayOfPvRoleDataPvRoleDataItem) ? get_class($arrayOfPvRoleDataPvRoleDataItem) : sprintf('%s(%s)', gettype($arrayOfPvRoleDataPvRoleDataItem), var_export($arrayOfPvRoleDataPvRoleDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvRoleData property can only contain items of type \StructType\PvRoleData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvRoleData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvRoleData[] $pvRoleData
     * @return \ArrayType\ArrayOfPvRoleData
     */
    public function setPvRoleData(array $pvRoleData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvRoleDataArrayErrorMessage = self::validatePvRoleDataForArrayConstraintsFromSetPvRoleData($pvRoleData))) {
            throw new \InvalidArgumentException($pvRoleDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvRoleData) || (is_array($pvRoleData) && empty($pvRoleData))) {
            unset($this->PvRoleData);
        } else {
            $this->PvRoleData = $pvRoleData;
        }
        return $this;
    }
    /**
     * Add item to PvRoleData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvRoleData $item
     * @return \ArrayType\ArrayOfPvRoleData
     */
    public function addToPvRoleData(\StructType\PvRoleData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvRoleData) {
            throw new \InvalidArgumentException(sprintf('The PvRoleData property can only contain items of type \StructType\PvRoleData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvRoleData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvRoleData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvRoleData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvRoleData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvRoleData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvRoleData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvRoleData
     */
    public function getAttributeName()
    {
        return 'PvRoleData';
    }
}
