<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvSbiCodeData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvSbiCodeData extends AbstractStructArrayBase
{
    /**
     * The PvSbiCodeData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvSbiCodeData[]
     */
    public $PvSbiCodeData;
    /**
     * Constructor method for ArrayOfPvSbiCodeData
     * @uses ArrayOfPvSbiCodeData::setPvSbiCodeData()
     * @param \StructType\PvSbiCodeData[] $pvSbiCodeData
     */
    public function __construct(array $pvSbiCodeData = array())
    {
        $this
            ->setPvSbiCodeData($pvSbiCodeData);
    }
    /**
     * Get PvSbiCodeData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvSbiCodeData[]|null
     */
    public function getPvSbiCodeData()
    {
        return isset($this->PvSbiCodeData) ? $this->PvSbiCodeData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvSbiCodeData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvSbiCodeData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvSbiCodeDataForArrayConstraintsFromSetPvSbiCodeData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvSbiCodeDataPvSbiCodeDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvSbiCodeDataPvSbiCodeDataItem instanceof \StructType\PvSbiCodeData) {
                $invalidValues[] = is_object($arrayOfPvSbiCodeDataPvSbiCodeDataItem) ? get_class($arrayOfPvSbiCodeDataPvSbiCodeDataItem) : sprintf('%s(%s)', gettype($arrayOfPvSbiCodeDataPvSbiCodeDataItem), var_export($arrayOfPvSbiCodeDataPvSbiCodeDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvSbiCodeData property can only contain items of type \StructType\PvSbiCodeData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvSbiCodeData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvSbiCodeData[] $pvSbiCodeData
     * @return \ArrayType\ArrayOfPvSbiCodeData
     */
    public function setPvSbiCodeData(array $pvSbiCodeData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvSbiCodeDataArrayErrorMessage = self::validatePvSbiCodeDataForArrayConstraintsFromSetPvSbiCodeData($pvSbiCodeData))) {
            throw new \InvalidArgumentException($pvSbiCodeDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvSbiCodeData) || (is_array($pvSbiCodeData) && empty($pvSbiCodeData))) {
            unset($this->PvSbiCodeData);
        } else {
            $this->PvSbiCodeData = $pvSbiCodeData;
        }
        return $this;
    }
    /**
     * Add item to PvSbiCodeData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvSbiCodeData $item
     * @return \ArrayType\ArrayOfPvSbiCodeData
     */
    public function addToPvSbiCodeData(\StructType\PvSbiCodeData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvSbiCodeData) {
            throw new \InvalidArgumentException(sprintf('The PvSbiCodeData property can only contain items of type \StructType\PvSbiCodeData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvSbiCodeData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvSbiCodeData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvSbiCodeData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvSbiCodeData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvSbiCodeData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvSbiCodeData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvSbiCodeData
     */
    public function getAttributeName()
    {
        return 'PvSbiCodeData';
    }
}
