<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvSystemDatastoreItemData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvSystemDatastoreItemData extends AbstractStructArrayBase
{
    /**
     * The PvSystemDatastoreItemData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvSystemDatastoreItemData[]
     */
    public $PvSystemDatastoreItemData;
    /**
     * Constructor method for ArrayOfPvSystemDatastoreItemData
     * @uses ArrayOfPvSystemDatastoreItemData::setPvSystemDatastoreItemData()
     * @param \StructType\PvSystemDatastoreItemData[] $pvSystemDatastoreItemData
     */
    public function __construct(array $pvSystemDatastoreItemData = array())
    {
        $this
            ->setPvSystemDatastoreItemData($pvSystemDatastoreItemData);
    }
    /**
     * Get PvSystemDatastoreItemData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvSystemDatastoreItemData[]|null
     */
    public function getPvSystemDatastoreItemData()
    {
        return isset($this->PvSystemDatastoreItemData) ? $this->PvSystemDatastoreItemData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvSystemDatastoreItemData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvSystemDatastoreItemData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvSystemDatastoreItemDataForArrayConstraintsFromSetPvSystemDatastoreItemData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvSystemDatastoreItemDataPvSystemDatastoreItemDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvSystemDatastoreItemDataPvSystemDatastoreItemDataItem instanceof \StructType\PvSystemDatastoreItemData) {
                $invalidValues[] = is_object($arrayOfPvSystemDatastoreItemDataPvSystemDatastoreItemDataItem) ? get_class($arrayOfPvSystemDatastoreItemDataPvSystemDatastoreItemDataItem) : sprintf('%s(%s)', gettype($arrayOfPvSystemDatastoreItemDataPvSystemDatastoreItemDataItem), var_export($arrayOfPvSystemDatastoreItemDataPvSystemDatastoreItemDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvSystemDatastoreItemData property can only contain items of type \StructType\PvSystemDatastoreItemData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvSystemDatastoreItemData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvSystemDatastoreItemData[] $pvSystemDatastoreItemData
     * @return \ArrayType\ArrayOfPvSystemDatastoreItemData
     */
    public function setPvSystemDatastoreItemData(array $pvSystemDatastoreItemData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvSystemDatastoreItemDataArrayErrorMessage = self::validatePvSystemDatastoreItemDataForArrayConstraintsFromSetPvSystemDatastoreItemData($pvSystemDatastoreItemData))) {
            throw new \InvalidArgumentException($pvSystemDatastoreItemDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvSystemDatastoreItemData) || (is_array($pvSystemDatastoreItemData) && empty($pvSystemDatastoreItemData))) {
            unset($this->PvSystemDatastoreItemData);
        } else {
            $this->PvSystemDatastoreItemData = $pvSystemDatastoreItemData;
        }
        return $this;
    }
    /**
     * Add item to PvSystemDatastoreItemData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvSystemDatastoreItemData $item
     * @return \ArrayType\ArrayOfPvSystemDatastoreItemData
     */
    public function addToPvSystemDatastoreItemData(\StructType\PvSystemDatastoreItemData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvSystemDatastoreItemData) {
            throw new \InvalidArgumentException(sprintf('The PvSystemDatastoreItemData property can only contain items of type \StructType\PvSystemDatastoreItemData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvSystemDatastoreItemData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvSystemDatastoreItemData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvSystemDatastoreItemData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvSystemDatastoreItemData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvSystemDatastoreItemData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvSystemDatastoreItemData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvSystemDatastoreItemData
     */
    public function getAttributeName()
    {
        return 'PvSystemDatastoreItemData';
    }
}
