<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvTranslationData2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvTranslationData2 extends AbstractStructArrayBase
{
    /**
     * The PvTranslationData2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvTranslationData2[]
     */
    public $PvTranslationData2;
    /**
     * Constructor method for ArrayOfPvTranslationData2
     * @uses ArrayOfPvTranslationData2::setPvTranslationData2()
     * @param \StructType\PvTranslationData2[] $pvTranslationData2
     */
    public function __construct(array $pvTranslationData2 = array())
    {
        $this
            ->setPvTranslationData2($pvTranslationData2);
    }
    /**
     * Get PvTranslationData2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvTranslationData2[]|null
     */
    public function getPvTranslationData2()
    {
        return isset($this->PvTranslationData2) ? $this->PvTranslationData2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvTranslationData2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvTranslationData2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvTranslationData2ForArrayConstraintsFromSetPvTranslationData2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvTranslationData2PvTranslationData2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPvTranslationData2PvTranslationData2Item instanceof \StructType\PvTranslationData2) {
                $invalidValues[] = is_object($arrayOfPvTranslationData2PvTranslationData2Item) ? get_class($arrayOfPvTranslationData2PvTranslationData2Item) : sprintf('%s(%s)', gettype($arrayOfPvTranslationData2PvTranslationData2Item), var_export($arrayOfPvTranslationData2PvTranslationData2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvTranslationData2 property can only contain items of type \StructType\PvTranslationData2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvTranslationData2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvTranslationData2[] $pvTranslationData2
     * @return \ArrayType\ArrayOfPvTranslationData2
     */
    public function setPvTranslationData2(array $pvTranslationData2 = array())
    {
        // validation for constraint: array
        if ('' !== ($pvTranslationData2ArrayErrorMessage = self::validatePvTranslationData2ForArrayConstraintsFromSetPvTranslationData2($pvTranslationData2))) {
            throw new \InvalidArgumentException($pvTranslationData2ArrayErrorMessage, __LINE__);
        }
        if (is_null($pvTranslationData2) || (is_array($pvTranslationData2) && empty($pvTranslationData2))) {
            unset($this->PvTranslationData2);
        } else {
            $this->PvTranslationData2 = $pvTranslationData2;
        }
        return $this;
    }
    /**
     * Add item to PvTranslationData2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PvTranslationData2 $item
     * @return \ArrayType\ArrayOfPvTranslationData2
     */
    public function addToPvTranslationData2(\StructType\PvTranslationData2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvTranslationData2) {
            throw new \InvalidArgumentException(sprintf('The PvTranslationData2 property can only contain items of type \StructType\PvTranslationData2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvTranslationData2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvTranslationData2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvTranslationData2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvTranslationData2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvTranslationData2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvTranslationData2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvTranslationData2
     */
    public function getAttributeName()
    {
        return 'PvTranslationData2';
    }
}
