<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvUnitData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvUnitData extends AbstractStructArrayBase
{
    /**
     * The PvUnitData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvUnitData[]
     */
    public $PvUnitData;
    /**
     * Constructor method for ArrayOfPvUnitData
     * @uses ArrayOfPvUnitData::setPvUnitData()
     * @param \StructType\PvUnitData[] $pvUnitData
     */
    public function __construct(array $pvUnitData = array())
    {
        $this
            ->setPvUnitData($pvUnitData);
    }
    /**
     * Get PvUnitData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvUnitData[]|null
     */
    public function getPvUnitData()
    {
        return isset($this->PvUnitData) ? $this->PvUnitData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvUnitData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvUnitData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvUnitDataForArrayConstraintsFromSetPvUnitData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvUnitDataPvUnitDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvUnitDataPvUnitDataItem instanceof \StructType\PvUnitData) {
                $invalidValues[] = is_object($arrayOfPvUnitDataPvUnitDataItem) ? get_class($arrayOfPvUnitDataPvUnitDataItem) : sprintf('%s(%s)', gettype($arrayOfPvUnitDataPvUnitDataItem), var_export($arrayOfPvUnitDataPvUnitDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvUnitData property can only contain items of type \StructType\PvUnitData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvUnitData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvUnitData[] $pvUnitData
     * @return \ArrayType\ArrayOfPvUnitData
     */
    public function setPvUnitData(array $pvUnitData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvUnitDataArrayErrorMessage = self::validatePvUnitDataForArrayConstraintsFromSetPvUnitData($pvUnitData))) {
            throw new \InvalidArgumentException($pvUnitDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvUnitData) || (is_array($pvUnitData) && empty($pvUnitData))) {
            unset($this->PvUnitData);
        } else {
            $this->PvUnitData = $pvUnitData;
        }
        return $this;
    }
    /**
     * Add item to PvUnitData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvUnitData $item
     * @return \ArrayType\ArrayOfPvUnitData
     */
    public function addToPvUnitData(\StructType\PvUnitData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvUnitData) {
            throw new \InvalidArgumentException(sprintf('The PvUnitData property can only contain items of type \StructType\PvUnitData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvUnitData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvUnitData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvUnitData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvUnitData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvUnitData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvUnitData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvUnitData
     */
    public function getAttributeName()
    {
        return 'PvUnitData';
    }
}
