<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvUserDatabase ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvUserDatabase extends AbstractStructArrayBase
{
    /**
     * The PvUserDatabase
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvUserDatabase[]
     */
    public $PvUserDatabase;
    /**
     * Constructor method for ArrayOfPvUserDatabase
     * @uses ArrayOfPvUserDatabase::setPvUserDatabase()
     * @param \StructType\PvUserDatabase[] $pvUserDatabase
     */
    public function __construct(array $pvUserDatabase = array())
    {
        $this
            ->setPvUserDatabase($pvUserDatabase);
    }
    /**
     * Get PvUserDatabase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvUserDatabase[]|null
     */
    public function getPvUserDatabase()
    {
        return isset($this->PvUserDatabase) ? $this->PvUserDatabase : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvUserDatabase method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvUserDatabase method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvUserDatabaseForArrayConstraintsFromSetPvUserDatabase(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvUserDatabasePvUserDatabaseItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvUserDatabasePvUserDatabaseItem instanceof \StructType\PvUserDatabase) {
                $invalidValues[] = is_object($arrayOfPvUserDatabasePvUserDatabaseItem) ? get_class($arrayOfPvUserDatabasePvUserDatabaseItem) : sprintf('%s(%s)', gettype($arrayOfPvUserDatabasePvUserDatabaseItem), var_export($arrayOfPvUserDatabasePvUserDatabaseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvUserDatabase property can only contain items of type \StructType\PvUserDatabase, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvUserDatabase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvUserDatabase[] $pvUserDatabase
     * @return \ArrayType\ArrayOfPvUserDatabase
     */
    public function setPvUserDatabase(array $pvUserDatabase = array())
    {
        // validation for constraint: array
        if ('' !== ($pvUserDatabaseArrayErrorMessage = self::validatePvUserDatabaseForArrayConstraintsFromSetPvUserDatabase($pvUserDatabase))) {
            throw new \InvalidArgumentException($pvUserDatabaseArrayErrorMessage, __LINE__);
        }
        if (is_null($pvUserDatabase) || (is_array($pvUserDatabase) && empty($pvUserDatabase))) {
            unset($this->PvUserDatabase);
        } else {
            $this->PvUserDatabase = $pvUserDatabase;
        }
        return $this;
    }
    /**
     * Add item to PvUserDatabase value
     * @throws \InvalidArgumentException
     * @param \StructType\PvUserDatabase $item
     * @return \ArrayType\ArrayOfPvUserDatabase
     */
    public function addToPvUserDatabase(\StructType\PvUserDatabase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvUserDatabase) {
            throw new \InvalidArgumentException(sprintf('The PvUserDatabase property can only contain items of type \StructType\PvUserDatabase, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvUserDatabase[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvUserDatabase|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvUserDatabase|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvUserDatabase|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvUserDatabase|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvUserDatabase|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvUserDatabase
     */
    public function getAttributeName()
    {
        return 'PvUserDatabase';
    }
}
