<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvVatData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvVatData extends AbstractStructArrayBase
{
    /**
     * The PvVatData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvVatData[]
     */
    public $PvVatData;
    /**
     * Constructor method for ArrayOfPvVatData
     * @uses ArrayOfPvVatData::setPvVatData()
     * @param \StructType\PvVatData[] $pvVatData
     */
    public function __construct(array $pvVatData = array())
    {
        $this
            ->setPvVatData($pvVatData);
    }
    /**
     * Get PvVatData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvVatData[]|null
     */
    public function getPvVatData()
    {
        return isset($this->PvVatData) ? $this->PvVatData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvVatData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvVatData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvVatDataForArrayConstraintsFromSetPvVatData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvVatDataPvVatDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvVatDataPvVatDataItem instanceof \StructType\PvVatData) {
                $invalidValues[] = is_object($arrayOfPvVatDataPvVatDataItem) ? get_class($arrayOfPvVatDataPvVatDataItem) : sprintf('%s(%s)', gettype($arrayOfPvVatDataPvVatDataItem), var_export($arrayOfPvVatDataPvVatDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvVatData property can only contain items of type \StructType\PvVatData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvVatData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvVatData[] $pvVatData
     * @return \ArrayType\ArrayOfPvVatData
     */
    public function setPvVatData(array $pvVatData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvVatDataArrayErrorMessage = self::validatePvVatDataForArrayConstraintsFromSetPvVatData($pvVatData))) {
            throw new \InvalidArgumentException($pvVatDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvVatData) || (is_array($pvVatData) && empty($pvVatData))) {
            unset($this->PvVatData);
        } else {
            $this->PvVatData = $pvVatData;
        }
        return $this;
    }
    /**
     * Add item to PvVatData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvVatData $item
     * @return \ArrayType\ArrayOfPvVatData
     */
    public function addToPvVatData(\StructType\PvVatData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvVatData) {
            throw new \InvalidArgumentException(sprintf('The PvVatData property can only contain items of type \StructType\PvVatData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvVatData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvVatData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvVatData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvVatData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvVatData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvVatData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvVatData
     */
    public function getAttributeName()
    {
        return 'PvVatData';
    }
}
