<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvViewDefinitionData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvViewDefinitionData extends AbstractStructArrayBase
{
    /**
     * The PvViewDefinitionData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvViewDefinitionData[]
     */
    public $PvViewDefinitionData;
    /**
     * Constructor method for ArrayOfPvViewDefinitionData
     * @uses ArrayOfPvViewDefinitionData::setPvViewDefinitionData()
     * @param \StructType\PvViewDefinitionData[] $pvViewDefinitionData
     */
    public function __construct(array $pvViewDefinitionData = array())
    {
        $this
            ->setPvViewDefinitionData($pvViewDefinitionData);
    }
    /**
     * Get PvViewDefinitionData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvViewDefinitionData[]|null
     */
    public function getPvViewDefinitionData()
    {
        return isset($this->PvViewDefinitionData) ? $this->PvViewDefinitionData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvViewDefinitionData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvViewDefinitionData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvViewDefinitionDataForArrayConstraintsFromSetPvViewDefinitionData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvViewDefinitionDataPvViewDefinitionDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvViewDefinitionDataPvViewDefinitionDataItem instanceof \StructType\PvViewDefinitionData) {
                $invalidValues[] = is_object($arrayOfPvViewDefinitionDataPvViewDefinitionDataItem) ? get_class($arrayOfPvViewDefinitionDataPvViewDefinitionDataItem) : sprintf('%s(%s)', gettype($arrayOfPvViewDefinitionDataPvViewDefinitionDataItem), var_export($arrayOfPvViewDefinitionDataPvViewDefinitionDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvViewDefinitionData property can only contain items of type \StructType\PvViewDefinitionData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvViewDefinitionData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvViewDefinitionData[] $pvViewDefinitionData
     * @return \ArrayType\ArrayOfPvViewDefinitionData
     */
    public function setPvViewDefinitionData(array $pvViewDefinitionData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvViewDefinitionDataArrayErrorMessage = self::validatePvViewDefinitionDataForArrayConstraintsFromSetPvViewDefinitionData($pvViewDefinitionData))) {
            throw new \InvalidArgumentException($pvViewDefinitionDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvViewDefinitionData) || (is_array($pvViewDefinitionData) && empty($pvViewDefinitionData))) {
            unset($this->PvViewDefinitionData);
        } else {
            $this->PvViewDefinitionData = $pvViewDefinitionData;
        }
        return $this;
    }
    /**
     * Add item to PvViewDefinitionData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvViewDefinitionData $item
     * @return \ArrayType\ArrayOfPvViewDefinitionData
     */
    public function addToPvViewDefinitionData(\StructType\PvViewDefinitionData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvViewDefinitionData) {
            throw new \InvalidArgumentException(sprintf('The PvViewDefinitionData property can only contain items of type \StructType\PvViewDefinitionData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvViewDefinitionData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvViewDefinitionData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvViewDefinitionData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvViewDefinitionData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvViewDefinitionData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvViewDefinitionData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvViewDefinitionData
     */
    public function getAttributeName()
    {
        return 'PvViewDefinitionData';
    }
}
