<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvWorkflowData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvWorkflowData extends AbstractStructArrayBase
{
    /**
     * The PvWorkflowData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvWorkflowData[]
     */
    public $PvWorkflowData;
    /**
     * Constructor method for ArrayOfPvWorkflowData
     * @uses ArrayOfPvWorkflowData::setPvWorkflowData()
     * @param \StructType\PvWorkflowData[] $pvWorkflowData
     */
    public function __construct(array $pvWorkflowData = array())
    {
        $this
            ->setPvWorkflowData($pvWorkflowData);
    }
    /**
     * Get PvWorkflowData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvWorkflowData[]|null
     */
    public function getPvWorkflowData()
    {
        return isset($this->PvWorkflowData) ? $this->PvWorkflowData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvWorkflowData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvWorkflowData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvWorkflowDataForArrayConstraintsFromSetPvWorkflowData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvWorkflowDataPvWorkflowDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvWorkflowDataPvWorkflowDataItem instanceof \StructType\PvWorkflowData) {
                $invalidValues[] = is_object($arrayOfPvWorkflowDataPvWorkflowDataItem) ? get_class($arrayOfPvWorkflowDataPvWorkflowDataItem) : sprintf('%s(%s)', gettype($arrayOfPvWorkflowDataPvWorkflowDataItem), var_export($arrayOfPvWorkflowDataPvWorkflowDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvWorkflowData property can only contain items of type \StructType\PvWorkflowData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvWorkflowData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvWorkflowData[] $pvWorkflowData
     * @return \ArrayType\ArrayOfPvWorkflowData
     */
    public function setPvWorkflowData(array $pvWorkflowData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvWorkflowDataArrayErrorMessage = self::validatePvWorkflowDataForArrayConstraintsFromSetPvWorkflowData($pvWorkflowData))) {
            throw new \InvalidArgumentException($pvWorkflowDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvWorkflowData) || (is_array($pvWorkflowData) && empty($pvWorkflowData))) {
            unset($this->PvWorkflowData);
        } else {
            $this->PvWorkflowData = $pvWorkflowData;
        }
        return $this;
    }
    /**
     * Add item to PvWorkflowData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvWorkflowData $item
     * @return \ArrayType\ArrayOfPvWorkflowData
     */
    public function addToPvWorkflowData(\StructType\PvWorkflowData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvWorkflowData) {
            throw new \InvalidArgumentException(sprintf('The PvWorkflowData property can only contain items of type \StructType\PvWorkflowData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvWorkflowData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvWorkflowData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvWorkflowData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvWorkflowData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvWorkflowData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvWorkflowData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvWorkflowData
     */
    public function getAttributeName()
    {
        return 'PvWorkflowData';
    }
}
