<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPvWorkflowStepData ArrayType
 * @subpackage Arrays
 */
class ArrayOfPvWorkflowStepData extends AbstractStructArrayBase
{
    /**
     * The PvWorkflowStepData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PvWorkflowStepData[]
     */
    public $PvWorkflowStepData;
    /**
     * Constructor method for ArrayOfPvWorkflowStepData
     * @uses ArrayOfPvWorkflowStepData::setPvWorkflowStepData()
     * @param \StructType\PvWorkflowStepData[] $pvWorkflowStepData
     */
    public function __construct(array $pvWorkflowStepData = array())
    {
        $this
            ->setPvWorkflowStepData($pvWorkflowStepData);
    }
    /**
     * Get PvWorkflowStepData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PvWorkflowStepData[]|null
     */
    public function getPvWorkflowStepData()
    {
        return isset($this->PvWorkflowStepData) ? $this->PvWorkflowStepData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPvWorkflowStepData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPvWorkflowStepData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePvWorkflowStepDataForArrayConstraintsFromSetPvWorkflowStepData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPvWorkflowStepDataPvWorkflowStepDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPvWorkflowStepDataPvWorkflowStepDataItem instanceof \StructType\PvWorkflowStepData) {
                $invalidValues[] = is_object($arrayOfPvWorkflowStepDataPvWorkflowStepDataItem) ? get_class($arrayOfPvWorkflowStepDataPvWorkflowStepDataItem) : sprintf('%s(%s)', gettype($arrayOfPvWorkflowStepDataPvWorkflowStepDataItem), var_export($arrayOfPvWorkflowStepDataPvWorkflowStepDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PvWorkflowStepData property can only contain items of type \StructType\PvWorkflowStepData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PvWorkflowStepData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PvWorkflowStepData[] $pvWorkflowStepData
     * @return \ArrayType\ArrayOfPvWorkflowStepData
     */
    public function setPvWorkflowStepData(array $pvWorkflowStepData = array())
    {
        // validation for constraint: array
        if ('' !== ($pvWorkflowStepDataArrayErrorMessage = self::validatePvWorkflowStepDataForArrayConstraintsFromSetPvWorkflowStepData($pvWorkflowStepData))) {
            throw new \InvalidArgumentException($pvWorkflowStepDataArrayErrorMessage, __LINE__);
        }
        if (is_null($pvWorkflowStepData) || (is_array($pvWorkflowStepData) && empty($pvWorkflowStepData))) {
            unset($this->PvWorkflowStepData);
        } else {
            $this->PvWorkflowStepData = $pvWorkflowStepData;
        }
        return $this;
    }
    /**
     * Add item to PvWorkflowStepData value
     * @throws \InvalidArgumentException
     * @param \StructType\PvWorkflowStepData $item
     * @return \ArrayType\ArrayOfPvWorkflowStepData
     */
    public function addToPvWorkflowStepData(\StructType\PvWorkflowStepData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PvWorkflowStepData) {
            throw new \InvalidArgumentException(sprintf('The PvWorkflowStepData property can only contain items of type \StructType\PvWorkflowStepData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PvWorkflowStepData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PvWorkflowStepData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PvWorkflowStepData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PvWorkflowStepData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PvWorkflowStepData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PvWorkflowStepData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PvWorkflowStepData
     */
    public function getAttributeName()
    {
        return 'PvWorkflowStepData';
    }
}
