<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRelationPhoneNumbersType ArrayType
 * @subpackage Arrays
 */
class ArrayOfRelationPhoneNumbersType extends AbstractStructArrayBase
{
    /**
     * The RelationPhoneNumbersType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RelationPhoneNumbersType[]
     */
    public $RelationPhoneNumbersType;
    /**
     * Constructor method for ArrayOfRelationPhoneNumbersType
     * @uses ArrayOfRelationPhoneNumbersType::setRelationPhoneNumbersType()
     * @param \StructType\RelationPhoneNumbersType[] $relationPhoneNumbersType
     */
    public function __construct(array $relationPhoneNumbersType = array())
    {
        $this
            ->setRelationPhoneNumbersType($relationPhoneNumbersType);
    }
    /**
     * Get RelationPhoneNumbersType value
     * @return \StructType\RelationPhoneNumbersType[]|null
     */
    public function getRelationPhoneNumbersType()
    {
        return $this->RelationPhoneNumbersType;
    }
    /**
     * This method is responsible for validating the values passed to the setRelationPhoneNumbersType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelationPhoneNumbersType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelationPhoneNumbersTypeForArrayConstraintsFromSetRelationPhoneNumbersType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRelationPhoneNumbersTypeRelationPhoneNumbersTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfRelationPhoneNumbersTypeRelationPhoneNumbersTypeItem instanceof \StructType\RelationPhoneNumbersType) {
                $invalidValues[] = is_object($arrayOfRelationPhoneNumbersTypeRelationPhoneNumbersTypeItem) ? get_class($arrayOfRelationPhoneNumbersTypeRelationPhoneNumbersTypeItem) : sprintf('%s(%s)', gettype($arrayOfRelationPhoneNumbersTypeRelationPhoneNumbersTypeItem), var_export($arrayOfRelationPhoneNumbersTypeRelationPhoneNumbersTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RelationPhoneNumbersType property can only contain items of type \StructType\RelationPhoneNumbersType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RelationPhoneNumbersType value
     * @throws \InvalidArgumentException
     * @param \StructType\RelationPhoneNumbersType[] $relationPhoneNumbersType
     * @return \ArrayType\ArrayOfRelationPhoneNumbersType
     */
    public function setRelationPhoneNumbersType(array $relationPhoneNumbersType = array())
    {
        // validation for constraint: array
        if ('' !== ($relationPhoneNumbersTypeArrayErrorMessage = self::validateRelationPhoneNumbersTypeForArrayConstraintsFromSetRelationPhoneNumbersType($relationPhoneNumbersType))) {
            throw new \InvalidArgumentException($relationPhoneNumbersTypeArrayErrorMessage, __LINE__);
        }
        $this->RelationPhoneNumbersType = $relationPhoneNumbersType;
        return $this;
    }
    /**
     * Add item to RelationPhoneNumbersType value
     * @throws \InvalidArgumentException
     * @param \StructType\RelationPhoneNumbersType $item
     * @return \ArrayType\ArrayOfRelationPhoneNumbersType
     */
    public function addToRelationPhoneNumbersType(\StructType\RelationPhoneNumbersType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RelationPhoneNumbersType) {
            throw new \InvalidArgumentException(sprintf('The RelationPhoneNumbersType property can only contain items of type \StructType\RelationPhoneNumbersType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RelationPhoneNumbersType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RelationPhoneNumbersType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RelationPhoneNumbersType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RelationPhoneNumbersType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RelationPhoneNumbersType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RelationPhoneNumbersType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RelationPhoneNumbersType
     */
    public function getAttributeName()
    {
        return 'RelationPhoneNumbersType';
    }
}
