<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTelephoneBookEntry ArrayType
 * @subpackage Arrays
 */
class ArrayOfTelephoneBookEntry extends AbstractStructArrayBase
{
    /**
     * The TelephoneBookEntry
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TelephoneBookEntry[]
     */
    public $TelephoneBookEntry;
    /**
     * Constructor method for ArrayOfTelephoneBookEntry
     * @uses ArrayOfTelephoneBookEntry::setTelephoneBookEntry()
     * @param \StructType\TelephoneBookEntry[] $telephoneBookEntry
     */
    public function __construct(array $telephoneBookEntry = array())
    {
        $this
            ->setTelephoneBookEntry($telephoneBookEntry);
    }
    /**
     * Get TelephoneBookEntry value
     * @return \StructType\TelephoneBookEntry[]|null
     */
    public function getTelephoneBookEntry()
    {
        return $this->TelephoneBookEntry;
    }
    /**
     * This method is responsible for validating the values passed to the setTelephoneBookEntry method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTelephoneBookEntry method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTelephoneBookEntryForArrayConstraintsFromSetTelephoneBookEntry(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTelephoneBookEntryTelephoneBookEntryItem) {
            // validation for constraint: itemType
            if (!$arrayOfTelephoneBookEntryTelephoneBookEntryItem instanceof \StructType\TelephoneBookEntry) {
                $invalidValues[] = is_object($arrayOfTelephoneBookEntryTelephoneBookEntryItem) ? get_class($arrayOfTelephoneBookEntryTelephoneBookEntryItem) : sprintf('%s(%s)', gettype($arrayOfTelephoneBookEntryTelephoneBookEntryItem), var_export($arrayOfTelephoneBookEntryTelephoneBookEntryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TelephoneBookEntry property can only contain items of type \StructType\TelephoneBookEntry, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TelephoneBookEntry value
     * @throws \InvalidArgumentException
     * @param \StructType\TelephoneBookEntry[] $telephoneBookEntry
     * @return \ArrayType\ArrayOfTelephoneBookEntry
     */
    public function setTelephoneBookEntry(array $telephoneBookEntry = array())
    {
        // validation for constraint: array
        if ('' !== ($telephoneBookEntryArrayErrorMessage = self::validateTelephoneBookEntryForArrayConstraintsFromSetTelephoneBookEntry($telephoneBookEntry))) {
            throw new \InvalidArgumentException($telephoneBookEntryArrayErrorMessage, __LINE__);
        }
        $this->TelephoneBookEntry = $telephoneBookEntry;
        return $this;
    }
    /**
     * Add item to TelephoneBookEntry value
     * @throws \InvalidArgumentException
     * @param \StructType\TelephoneBookEntry $item
     * @return \ArrayType\ArrayOfTelephoneBookEntry
     */
    public function addToTelephoneBookEntry(\StructType\TelephoneBookEntry $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TelephoneBookEntry) {
            throw new \InvalidArgumentException(sprintf('The TelephoneBookEntry property can only contain items of type \StructType\TelephoneBookEntry, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TelephoneBookEntry[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TelephoneBookEntry|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TelephoneBookEntry|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TelephoneBookEntry|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TelephoneBookEntry|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TelephoneBookEntry|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TelephoneBookEntry
     */
    public function getAttributeName()
    {
        return 'TelephoneBookEntry';
    }
}
