<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for System ServiceType
 * @subpackage Services
 */
class System extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SystemDatastoreGetItems
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SystemDatastoreGetItems $parameters
     * @return \StructType\SystemDatastoreGetItemsResponse|bool
     */
    public function SystemDatastoreGetItems(\StructType\SystemDatastoreGetItems $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SystemDatastoreGetItems($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\SystemDatastoreGetItemsResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
