<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ActivitySearchByFieldResult StructType
 * @subpackage Structs
 */
class ActivitySearchByFieldResult extends PvApiResult
{
    /**
     * The Activities
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPvActivityData
     */
    public $Activities;
    /**
     * The ErrorInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorInformation;
    /**
     * Constructor method for ActivitySearchByFieldResult
     * @uses ActivitySearchByFieldResult::setActivities()
     * @uses ActivitySearchByFieldResult::setErrorInformation()
     * @param \ArrayType\ArrayOfPvActivityData $activities
     * @param string $errorInformation
     */
    public function __construct(\ArrayType\ArrayOfPvActivityData $activities = null, $errorInformation = null)
    {
        $this
            ->setActivities($activities)
            ->setErrorInformation($errorInformation);
    }
    /**
     * Get Activities value
     * @return \ArrayType\ArrayOfPvActivityData|null
     */
    public function getActivities()
    {
        return $this->Activities;
    }
    /**
     * Set Activities value
     * @param \ArrayType\ArrayOfPvActivityData $activities
     * @return \StructType\ActivitySearchByFieldResult
     */
    public function setActivities(\ArrayType\ArrayOfPvActivityData $activities = null)
    {
        $this->Activities = $activities;
        return $this;
    }
    /**
     * Get ErrorInformation value
     * @return string|null
     */
    public function getErrorInformation()
    {
        return $this->ErrorInformation;
    }
    /**
     * Set ErrorInformation value
     * @param string $errorInformation
     * @return \StructType\ActivitySearchByFieldResult
     */
    public function setErrorInformation($errorInformation = null)
    {
        // validation for constraint: string
        if (!is_null($errorInformation) && !is_string($errorInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorInformation, true), gettype($errorInformation)), __LINE__);
        }
        $this->ErrorInformation = $errorInformation;
        return $this;
    }
}
