<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MobileCreateAccount StructType
 * @subpackage Structs
 */
class MobileCreateAccount extends AbstractStructBase
{
    /**
     * The apiKey
     * Meta information extracted from the WSDL
     * - base: s:string
     * - maxOccurs: 1
     * - minOccurs: 1
     * - pattern: [0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}
     * @var string
     */
    public $apiKey;
    /**
     * The accountData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\CreateDatabaseData
     */
    public $accountData;
    /**
     * Constructor method for MobileCreateAccount
     * @uses MobileCreateAccount::setApiKey()
     * @uses MobileCreateAccount::setAccountData()
     * @param string $apiKey
     * @param \StructType\CreateDatabaseData $accountData
     */
    public function __construct($apiKey = null, \StructType\CreateDatabaseData $accountData = null)
    {
        $this
            ->setApiKey($apiKey)
            ->setAccountData($accountData);
    }
    /**
     * Get apiKey value
     * @return string
     */
    public function getApiKey()
    {
        return $this->apiKey;
    }
    /**
     * Set apiKey value
     * @param string $apiKey
     * @return \StructType\MobileCreateAccount
     */
    public function setApiKey($apiKey = null)
    {
        // validation for constraint: string
        if (!is_null($apiKey) && !is_string($apiKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apiKey, true), gettype($apiKey)), __LINE__);
        }
        // validation for constraint: pattern([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12})
        if (!is_null($apiKey) && !preg_match('/[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}/', $apiKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression [0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}', var_export($apiKey, true)), __LINE__);
        }
        $this->apiKey = $apiKey;
        return $this;
    }
    /**
     * Get accountData value
     * @return \StructType\CreateDatabaseData
     */
    public function getAccountData()
    {
        return $this->accountData;
    }
    /**
     * Set accountData value
     * @param \StructType\CreateDatabaseData $accountData
     * @return \StructType\MobileCreateAccount
     */
    public function setAccountData(\StructType\CreateDatabaseData $accountData = null)
    {
        $this->accountData = $accountData;
        return $this;
    }
}
