<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductSearchByFieldExactResult StructType
 * @subpackage Structs
 */
class ProductSearchByFieldExactResult extends PvApiResult
{
    /**
     * The products
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPvProductData
     */
    public $products;
    /**
     * The ErrorInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorInformation;
    /**
     * Constructor method for ProductSearchByFieldExactResult
     * @uses ProductSearchByFieldExactResult::setProducts()
     * @uses ProductSearchByFieldExactResult::setErrorInformation()
     * @param \ArrayType\ArrayOfPvProductData $products
     * @param string $errorInformation
     */
    public function __construct(\ArrayType\ArrayOfPvProductData $products = null, $errorInformation = null)
    {
        $this
            ->setProducts($products)
            ->setErrorInformation($errorInformation);
    }
    /**
     * Get products value
     * @return \ArrayType\ArrayOfPvProductData|null
     */
    public function getProducts()
    {
        return $this->products;
    }
    /**
     * Set products value
     * @param \ArrayType\ArrayOfPvProductData $products
     * @return \StructType\ProductSearchByFieldExactResult
     */
    public function setProducts(\ArrayType\ArrayOfPvProductData $products = null)
    {
        $this->products = $products;
        return $this;
    }
    /**
     * Get ErrorInformation value
     * @return string|null
     */
    public function getErrorInformation()
    {
        return $this->ErrorInformation;
    }
    /**
     * Set ErrorInformation value
     * @param string $errorInformation
     * @return \StructType\ProductSearchByFieldExactResult
     */
    public function setErrorInformation($errorInformation = null)
    {
        // validation for constraint: string
        if (!is_null($errorInformation) && !is_string($errorInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorInformation, true), gettype($errorInformation)), __LINE__);
        }
        $this->ErrorInformation = $errorInformation;
        return $this;
    }
}
