<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PvUnitData StructType
 * @subpackage Structs
 */
class PvUnitData extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The FullName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FullName;
    /**
     * The FullNamePlural
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FullNamePlural;
    /**
     * The ShortName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ShortName;
    /**
     * Constructor method for PvUnitData
     * @uses PvUnitData::setId()
     * @uses PvUnitData::setFullName()
     * @uses PvUnitData::setFullNamePlural()
     * @uses PvUnitData::setShortName()
     * @param int $id
     * @param string $fullName
     * @param string $fullNamePlural
     * @param string $shortName
     */
    public function __construct($id = null, $fullName = null, $fullNamePlural = null, $shortName = null)
    {
        $this
            ->setId($id)
            ->setFullName($fullName)
            ->setFullNamePlural($fullNamePlural)
            ->setShortName($shortName);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\PvUnitData
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get FullName value
     * @return string|null
     */
    public function getFullName()
    {
        return $this->FullName;
    }
    /**
     * Set FullName value
     * @param string $fullName
     * @return \StructType\PvUnitData
     */
    public function setFullName($fullName = null)
    {
        // validation for constraint: string
        if (!is_null($fullName) && !is_string($fullName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fullName, true), gettype($fullName)), __LINE__);
        }
        $this->FullName = $fullName;
        return $this;
    }
    /**
     * Get FullNamePlural value
     * @return string|null
     */
    public function getFullNamePlural()
    {
        return $this->FullNamePlural;
    }
    /**
     * Set FullNamePlural value
     * @param string $fullNamePlural
     * @return \StructType\PvUnitData
     */
    public function setFullNamePlural($fullNamePlural = null)
    {
        // validation for constraint: string
        if (!is_null($fullNamePlural) && !is_string($fullNamePlural)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fullNamePlural, true), gettype($fullNamePlural)), __LINE__);
        }
        $this->FullNamePlural = $fullNamePlural;
        return $this;
    }
    /**
     * Get ShortName value
     * @return string|null
     */
    public function getShortName()
    {
        return $this->ShortName;
    }
    /**
     * Set ShortName value
     * @param string $shortName
     * @return \StructType\PvUnitData
     */
    public function setShortName($shortName = null)
    {
        // validation for constraint: string
        if (!is_null($shortName) && !is_string($shortName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shortName, true), gettype($shortName)), __LINE__);
        }
        $this->ShortName = $shortName;
        return $this;
    }
}
