<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubscriptionCreateResult StructType
 * @subpackage Structs
 */
class SubscriptionCreateResult extends PvApiResult
{
    /**
     * The Activity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PvActivityData
     */
    public $Activity;
    /**
     * The ProductLineData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PvProductLineData
     */
    public $ProductLineData;
    /**
     * Constructor method for SubscriptionCreateResult
     * @uses SubscriptionCreateResult::setActivity()
     * @uses SubscriptionCreateResult::setProductLineData()
     * @param \StructType\PvActivityData $activity
     * @param \StructType\PvProductLineData $productLineData
     */
    public function __construct(\StructType\PvActivityData $activity = null, \StructType\PvProductLineData $productLineData = null)
    {
        $this
            ->setActivity($activity)
            ->setProductLineData($productLineData);
    }
    /**
     * Get Activity value
     * @return \StructType\PvActivityData|null
     */
    public function getActivity()
    {
        return $this->Activity;
    }
    /**
     * Set Activity value
     * @param \StructType\PvActivityData $activity
     * @return \StructType\SubscriptionCreateResult
     */
    public function setActivity(\StructType\PvActivityData $activity = null)
    {
        $this->Activity = $activity;
        return $this;
    }
    /**
     * Get ProductLineData value
     * @return \StructType\PvProductLineData|null
     */
    public function getProductLineData()
    {
        return $this->ProductLineData;
    }
    /**
     * Set ProductLineData value
     * @param \StructType\PvProductLineData $productLineData
     * @return \StructType\SubscriptionCreateResult
     */
    public function setProductLineData(\StructType\PvProductLineData $productLineData = null)
    {
        $this->ProductLineData = $productLineData;
        return $this;
    }
}
