<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TelephoneBookEntry StructType
 * @subpackage Structs
 */
class TelephoneBookEntry extends AbstractStructBase
{
    /**
     * The relation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PvRelationData
     */
    public $relation;
    /**
     * The TelephoneNumbers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPvTelephoneNumberData
     */
    public $TelephoneNumbers;
    /**
     * Constructor method for TelephoneBookEntry
     * @uses TelephoneBookEntry::setRelation()
     * @uses TelephoneBookEntry::setTelephoneNumbers()
     * @param \StructType\PvRelationData $relation
     * @param \ArrayType\ArrayOfPvTelephoneNumberData $telephoneNumbers
     */
    public function __construct(\StructType\PvRelationData $relation = null, \ArrayType\ArrayOfPvTelephoneNumberData $telephoneNumbers = null)
    {
        $this
            ->setRelation($relation)
            ->setTelephoneNumbers($telephoneNumbers);
    }
    /**
     * Get relation value
     * @return \StructType\PvRelationData|null
     */
    public function getRelation()
    {
        return $this->relation;
    }
    /**
     * Set relation value
     * @param \StructType\PvRelationData $relation
     * @return \StructType\TelephoneBookEntry
     */
    public function setRelation(\StructType\PvRelationData $relation = null)
    {
        $this->relation = $relation;
        return $this;
    }
    /**
     * Get TelephoneNumbers value
     * @return \ArrayType\ArrayOfPvTelephoneNumberData|null
     */
    public function getTelephoneNumbers()
    {
        return $this->TelephoneNumbers;
    }
    /**
     * Set TelephoneNumbers value
     * @param \ArrayType\ArrayOfPvTelephoneNumberData $telephoneNumbers
     * @return \StructType\TelephoneBookEntry
     */
    public function setTelephoneNumbers(\ArrayType\ArrayOfPvTelephoneNumberData $telephoneNumbers = null)
    {
        $this->TelephoneNumbers = $telephoneNumbers;
        return $this;
    }
}
