<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UsersGetActive StructType
 * @subpackage Structs
 */
class UsersGetActive extends AbstractStructBase
{
    /**
     * The includeImages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $includeImages;
    /**
     * The credentials
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ApiCredentials
     */
    public $credentials;
    /**
     * Constructor method for UsersGetActive
     * @uses UsersGetActive::setIncludeImages()
     * @uses UsersGetActive::setCredentials()
     * @param bool $includeImages
     * @param \StructType\ApiCredentials $credentials
     */
    public function __construct($includeImages = null, \StructType\ApiCredentials $credentials = null)
    {
        $this
            ->setIncludeImages($includeImages)
            ->setCredentials($credentials);
    }
    /**
     * Get includeImages value
     * @return bool
     */
    public function getIncludeImages()
    {
        return $this->includeImages;
    }
    /**
     * Set includeImages value
     * @param bool $includeImages
     * @return \StructType\UsersGetActive
     */
    public function setIncludeImages($includeImages = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeImages) && !is_bool($includeImages)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeImages, true), gettype($includeImages)), __LINE__);
        }
        $this->includeImages = $includeImages;
        return $this;
    }
    /**
     * Get credentials value
     * @return \StructType\ApiCredentials|null
     */
    public function getCredentials()
    {
        return $this->credentials;
    }
    /**
     * Set credentials value
     * @param \StructType\ApiCredentials $credentials
     * @return \StructType\UsersGetActive
     */
    public function setCredentials(\StructType\ApiCredentials $credentials = null)
    {
        $this->credentials = $credentials;
        return $this;
    }
}
